﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Linq;
using SyncfusionMvcApplication90;
using SyncfusionMvcApplication90.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Net;
namespace SyncfusionMvcApplication90.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        NORTHWNDEntities3 db = new NORTHWNDEntities3();
        public ActionResult GridFeatures()
        {
            var DataSource = OrderRepository.GetAllRecords();
            ViewBag.datasource = DataSource;
            return View();
        }

        public ActionResult DataSource(DataManager dm)
        {
            DataOperations ds = new DataOperations();

            var data = ds.Execute(OrderRepository.GetAllRecords().ToList(), dm);
            return Json(new { result = data, count = db.Orders.ToList().Count }, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Insert(EditableOrder value)
        {
            if (!ModelState.IsValid)
            {
                var message = string.Join(" | ", ModelState.Values
       .SelectMany(v => v.Errors)
       .Select(e => e.ErrorMessage));
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, message);
            }
            OrderRepository.Add(value);
           var data =  OrderRepository.GetAllRecords();
            
            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Update(EditableOrder value)
        {
            if (!ModelState.IsValid)
            {
                var message = string.Join(" | ", ModelState.Values
       .SelectMany(v => v.Errors)
       .Select(e => e.ErrorMessage));
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, message);
            }
            EditableOrder old = OrderRepository.GetAllRecords().Where(o => o.OrderID == value.OrderID).SingleOrDefault();
            return Json(OrderRepository.GetAllRecords(), JsonRequestBehavior.AllowGet);
        }
       

    }
}
